#!/usr/bin/env /opt/lampp/bin/php
<?php
// NOTE: Be sure to run this script with the fully qualified path.
//
// Load the config.
require_once dirname(__FILE__) . '/include/tapatio_poll_twitter.inc';
$config = new Config;


// Include system daemon
// http://kevin.vanzonneveld.net/techblog/article/create_daemons_in_php/
require_once "System/Daemon.php";                 // Include the Class
 
// Include some awesome logger.
// http://www.indelible.org/php/Log/guide.html
require_once "Log.php";

// Load the twitter daemon class.
require_once dirname(__FILE__) . '/include/class.TwitterDaemon.php';

// Create a global logger.
$logger = @Log::factory(
  $config->logger_conf['type'], '', 'tapatio_poll_twitter', array(), 
  $config->logger_conf['level']);

// Drupal error handler is now in place and we need to take it
// over.
restore_error_handler();
//set_error_handler('tapatio_error_handler');

// Set up daemon.
// System_Daemon::setOption("appName", "mydaemon");  // Minimum configuration
// System_Daemon::start();                           // Spawn Deamon!

$consumer = new threadedTwitterUserTweetFinder(5);
$producer = new threadedTwitterUserFeeder(5, $consumer);

// The parent will feed the the consumer
$pid = pcntl_fork();
if ($pid == -1) {
  $logger->err('[fork] Duplication impossible');
}
else if ($pid) {
  $producer->handle();
}
else {
  $consumer->handle();
}

function tapatio_error_handler ($errno, $message, 
  $filename, $line, $context) {
    return TRUE;
    global $logger;
    //print_r($logger);

  $log_message = $message .' at '. $filename .':'. $line;
  $function = 'log';
  switch ($errno) {
    case E_USER_NOTICE:
      $function = 'notice';
      break;
    case E_USER_WARNING:
      $function = 'warning';
      break;
    case E_USER_ERROR:
      $function = 'err';
      break;
  }
  $logger->$function($log_message);
  return TRUE;
}
?>
