/**
 * Toggle the visibility of a fieldset using smooth animations
 */
if (Drupal.jsEnabled) {
  $(document).ready(function() {
    $('fieldset.collapsible > legend').each(function() {
      var fieldset = $(this.parentNode);
      // Expand if there are errors inside
      if ($('input.error, textarea.error, select.error', fieldset).size() > 0) {
        fieldset.removeClass('collapsed');
      }

      // Turn the legend into a clickable link and wrap the contents of the fieldset
      // in a div for easier animation
      var text = this.innerHTML;
      $(this).empty().append($('<a href="#">'+ text +'</a>').click(function() {
        var fieldset = $(this).parents('fieldset:first')[0];
        // Don't animate multiple times
        if (!fieldset.animating) {
          fieldset.animating = true;

        if ($(fieldset).is('.collapsed')) {
          var content = $('> div', fieldset).slideDown('medium', function() {
            $(this.parentNode).removeClass('collapsed');
            this.parentNode.animating = false;
          });
        }
        else {
          var content = $('> div', fieldset).slideUp('medium', function() {
            $(this.parentNode).addClass('collapsed');
            this.parentNode.animating = false;
          });
        }
        }
        return false;
      })).after($('<div class="fieldset-wrapper"></div>').append(fieldset.children(':not(legend)')));
    });
  });
}
