// This will add AJAX Behavior to the Comms delete link.
if (Drupal.jsEnabled) {
  // Process the feedback from the AJAX delete function.
  var comms_process_delete = function(data) {
    var result = Drupal.parseJson(data);

    // The ajax delete function supports the deletion of multiple nodes but
    // we are only dealing with one at a time here.
    var nid = result.nids;

    // Isolate the message section for the node in question.
    var message = $('.comms #node-'+nid+' .message');

    // In case a delete was requested and the previous confirmation did not time
    // out, clear it.  Then if we recieved a new confirmation display it and 
    // schedule the removal.
    if (result.confirmation.length) {
      message.empty();
      message.hide();
      message.html(result.confirmation);
      message.append(
        '<br /><a href="#" id="yes">Yes</a>, '+
        '<a href="#" id="cancel">cancel</a>');

      $('a#yes', message)
        .bind('click', function() {
        $.post('/comms/delete/'+ result.nids.split(' ').join('+') +'/1', 
          null, comms_process_delete);
        return false;
      });

      $('a#cancel', message).bind('click', function() {
        message.fadeOut("slow");
      });

      message.fadeIn("slow");
      return;
    }

    // In case a delete was requested and the previous message did not time
    // out, clear it.  Then if we recieved a new message display it and 
    // schedule the removal.
    if (result.message.length) {
      message.empty();
      message.hide();
      message.html(result.message);
      message.fadeIn("slow");
      setTimeout(function() { message.fadeOut("slow"); }, 5000);
      if (result.error) {
        return;
      }
    }

    // If we get here then we have deleted some nodes.
    $('.comms #node-'+nid).remove();
  }

  // This is the main code that should be run on [a] comms node[s].
  $(document).ready(function () {
    // Get the path that this js is in.  This is a total hack!
    var path = '';
    $('head script').each(function() {
      var matches = $(this).attr("src").match(/(.*)comms\.delete\.js/);
      if (matches && matches.length == 2) {
        path = matches[1];
      }
    });

    // Add AJAX behvior to all delete links.
    $('.comms_delete').each(function() {
      // Get the nid.
      var matches = $('a', this).attr("href").match(/\/node\/(\d+)\//);
      var nid;
      if (matches && matches.length == 2) {
        nid = matches[1];
      }

      // Remove the link.
      $('a', this).attr('href', '#');

      // Bind AJAX function.
      $('a', this).bind('click', function() {
        $.post('/comms/delete/'+ nid, 
          null, comms_process_delete);
        return false;
      });
    });
  });
};
