// This will set the AJAX behavior for the "update groups" form on the page
// This is for D6
// Drupal.behaviors.commsAddGroup = function(context) {
if (Drupal.jsEnabled) {

  // This is the callback function for the group remove from dispatch AJAX 
  // function.  We need to remove the group from the dispatch section.  If
  // this clears out the groups then we need to hide the dispatch section.
  // Lastly we need to add the item back into the select list.
  var comms_groups_process_delete = function(data) {
    var result = Drupal.parseJson(data);

    // In case a delete was requested and the previous message did not time
    // out, clear it.  Then if we recieved a new message display it and 
    // schedule the removal.
    $('.comms #node-'+ result.nid +' .message').hide();
    if (result.message.length) {
      $('.comms #node-'+ result.nid +' .message').text(result.message);
      $('.comms #node-'+ result.nid +' .message').fadeIn("slow");
      setTimeout(function() {
        $('.comms #node-'+ result.nid +' .message').fadeOut("slow");
        }, 5000);
      return;
    }

    $('.comms #node-'+ result.nid +' .dispatch .info img#'+ 
        result.gid).remove();
    $('.comms #node-'+ result.nid +' .dispatch .info a#'+ 
        result.gid).remove();

    // Remove extra commas.
    var info = $('.comms #node-'+ result.nid +' .dispatch .info').html(); 
    info = info.replace(/: *,/, ':');
    info = info.replace(/, *,/, ',');
    info = info.replace(/, *$/, '');
    $('.comms #node-'+ result.nid +' .dispatch .info').html(info); 

    if ($('.comms #node-'+result.nid+' .dispatch .info a').get().length == 0) 
    {
      $('.comms #node-'+ result.nid +' .dispatch').hide();
    }
    else {
      // Rewriting that section of html (to remove commas) also seems to 
      // remove the click handlers, so we will have to rebind them.
      $('.comms #node-'+ result.nid +' .dispatch .info img').each(function(){
        $(this).bind('click', function() {
          $.post('/comms/groups/'+ result.nid +'/'
            + $(this).attr('id') +'/remove', 
            null, comms_groups_process_delete);
          return false;
        });
      });
    }

    // it is already done on page load for all options.
    comms_groups_form_show(result.nid);
    $('.comms #node-'+ result.nid 
        +' .comms_groups_form select option[value="'
        + result.gid +'"]').removeAttr('selected').show();
  }


  // This is the callback function for the term remove links AJAX 
  // function.  We need to remove the term from the term list and the group i
  // from the dispatch section.
  var comms_tags_process_delete = function(data) {
    var result = Drupal.parseJson(data);

    // In case an add was requested and the previous message did not time
    // out, clear it.  Then if we recieved a new message display it and 
    // schedule the removal.
    $('.comms #node-'+ result.nid +' .message').hide();
    if (result.message.length) {
      $('.comms #node-'+ result.nid +' .message').text(result.message);
      $('.comms #node-'+ result.nid +' .message').fadeIn("slow");
      setTimeout(function() {
        $('.comms #node-'+ result.nid +' .message').fadeOut("slow");
        }, 5000);
      if (result.error) {
        return;
      }
    }

    // Unhide the term in the tags select list.
    comms_tags_form_show(result.nid);
    for (var tid in result.term) {
      // Remove the term from the term list.
      $('.comms #node-'+result.nid+' .terms li.taxonomy_term_'+tid).remove();
      $('.comms #node-'+ result.nid 
          +' .group_tag select option[value="'
          + tid +'"]').removeAttr('selected').show();
    }

    // We will let comms_groups_process_delete() handle message displays
    // and all handling of groups.  Since we could be working with more than
    // one group we need to manipulate the json object that 
    // comms_groups_process_delete() expects.
    data = data.replace(/"message"\s*:\s*"[^"]*"/, '"message": ""');
    for (var gid in result.gids) {
      data = data.replace(
          /"name"\s*:\s*"[^"]*"/, '"name": "'+ result.gids[gid] +'"');
      data = data.replace(/"gid"\s*:\s*"[^"]*"/, '"gid": "'+ gid +'"');
      comms_groups_process_delete(data);
    }
  }

  var comms_groups_process_add = function(data) {
    var result = Drupal.parseJson(data);

    // In case an add was requested and the previous message did not time
    // out, clear it.  Then if we recieved a new message display it and 
    // schedule the removal.
    $('.comms #node-'+ result.nid +' .message').hide();
    if (result.message.length) {
      $('.comms #node-'+ result.nid +' .message').text(result.message);
      $('.comms #node-'+ result.nid +' .message').fadeIn("slow");
      setTimeout(function() {
        $('.comms #node-'+ result.nid +' .message').fadeOut("slow");
        }, 5000);
      if (result.error) {
        return;
      }
    }

    // Hide the option in the select box.
    $('.comms #node-'+ result.nid 
      +" .groups select option[value='"+ result.gid +"']").hide();

    // Show the dispatch section just in case it is hidden.
    $('.comms #node-'+ result.nid +' .dispatch').show();

    // Get the path that this js is in.  This is a total hack!
    var path = '';
    $('head script').each(function(i, script) {
      var matches = $(script).attr("src").match(/(.*)comms\.groups\.js/);
      if (matches && matches.length == 2) {
        path = matches[1];
      }
    });

    // Add the group to the dispatch section.
    if ($('.comms #node-'+ result.nid +' .dispatch .info a').get().length) {
      $('.comms #node-'+ result.nid +' .dispatch .info')
        .append(', ');
    }
    $('.comms #node-'+ result.nid +' .dispatch .info')
      .append('<a id="'+ result.gid +'" href="/node/'+ result.gid 
          +'">'+ result.name +'</a><img id="'+ result.gid 
          +'" src="'+ path +'cancel.png" />');

    // Add AJAX functionality to clicking the cancel image.  This will remove
    // the group from the "dispatch to" groups.
    $('.comms #node-'+ result.nid +' div.dispatch .info img#'+ result.gid)
      .bind('click', function() {
        $.post('/comms/groups/'+ result.nid +'/'+ result.gid +'/remove', 
          null, comms_groups_process_delete);
        return false;
      });

    // Hide the groups section if it is empty.
    var num_visible =
      $('.comms #node-'+result.nid+' .groups select option:visible').length;
    if (num_visible == 0) {
      $('.comms #node-'+ result.nid +' .comms_groups_form').hide();
    };
  }

  var comms_tags_process_add = function(data) {
    var result = Drupal.parseJson(data);

    // In case an add was requested and the previous message did not time
    // out, clear it.  Then if we recieved a new message display it and 
    // schedule the removal.
    $('.comms #node-'+ result.nid +' .message').hide();
    if (result.message.length) {
      $('.comms #node-'+ result.nid +' .message').text(result.message);
      $('.comms #node-'+ result.nid +' .message').fadeIn("slow");
      setTimeout(function() {
        $('.comms #node-'+ result.nid +' .message').fadeOut("slow");
        }, 5000);
      if (result.error) {
        return;
      }
    }

    // Hide the option in the select box.
    $('.comms #node-'+ result.nid 
      +" .group_tag select option[value='"+ result.gid +"']").hide();

    // Add the groups to the dispatch section.
    // Clear out the message in case there was one.
    data = data.replace(/"message"\s*:\s*"[^"]*"/, '"message": ""');
    for (var gid in result.gids) {
      data = data.replace(
          /"name"\s*:\s*"[^"]*"/, '"name": "'+ result.gids[gid] +'"');
      data = data.replace(/"gid"\s*:\s*"[^"]*"/, '"gid": "'+ gid +'"');
      comms_groups_process_add(data);
    }

    // Add the terms to the node.
    var path = getModulePath();
    for (var tid in result.term) {
      console.log('comms_tags_process_add() tid: '+ tid +', term: '+ result.term[tid]);
      // Place the term.  .comms #node-<nid> .terms does not exist if there
      // are no existing bound terms!
      $('.comms #node-'+ result.nid +' .terms ul')
        .append('<li class="first last taxonomy_term_'+ tid +'">'+ 
          '<a class="taxonomy_term_'+ tid +'" title="" rel="tag" href="/taxonomy/term/'+ tid +'">'+ result.term[tid] +'</a></li>');

      // Append a cancel icon to it.
      $('.comms #node-'+ result.nid +' .terms a.taxonomy_term_'+ tid)
        .after(': <img id="'+tid+'" src="'+ path +'cancel.png" />');
      // Bind a click handler to the cancel icon.
      $('.comms #node-'+ result.nid +' .terms img#'+ tid)
        .bind('click', function() {
          $.post('/comms/groups/'+ result.nid +'/'+ tid +'/remove/tags', 
            null, comms_tags_process_delete);
        });
    }

    // Hide the tags section if it is empty.
    var num_visible =
      $('.comms #node-'+result.nid+' .group_tag select option:visible').length;
    if (num_visible == 0) {
      $('.comms #node-'+ result.nid +' .group_tag').hide();
    };
  }

  var comms_groups_form_show = function(nid) {
    var group_form =
      $('.comms #node-'+ nid +' .comms_groups_form');

    // If the group form is not visible show it, but then hide all of the
    // misc stuff we don't want dosplayed.
    if (! group_form.visible) {
      group_form.show();
    }

    // If all options are selected we want to hide the whole form.
    $('select option:selected', group_form).hide();

    // Hide the submit button.
    $('input.comms_group_submit', group_form).hide();
  }

  var comms_tags_form_show = function(nid) {
    var tag_form =
      $('.comms #node-'+ nid +' .group_tag');

    // If the tag form is not visible show it, but then hide all of the
    // misc stuff we don't want displayed.
    if (! tag_form.visible) {
      tag_form.show();
    }

    // If all options are selected we want to hide the whole form.
    $('select option:selected', tag_form).hide();

    // Hide the submit button.
    $('input.comms_group_submit', tag_form).hide();
  }

  var getModulePath = function() {
    var path = '';
    $('head script').each(function(i, script) {
      var matches = $(script).attr("src").match(/(.*)comms\.groups\.js/);
      if (matches && matches.length == 2) {
        path = matches[1];
      }
    });
    return path;
  }

  // This is the main code that should be run on each page that has comms 
  // groups, dispatching stuff on it.
  $(document).ready(function () {
    // Get the path that this js is in.  This is a total hack!
    var path = '';
    $('head script').each(function(i, script) {
      var matches = $(script).attr("src").match(/(.*)comms\.groups\.js/);
      if (matches && matches.length == 2) {
        path = matches[1];
      }
    });

    // If there are no groups bound to this node then we can hide it.
    $('div.dispatch').each(function() {
      if ($('.info a', this).get().length == 0) {
        $(this).hide();
      }
    });

    // Add delete icon / buttons next to each group name in the dispatch line.
    $('div.dispatch .info a').each(function(){
      $(this).after('<img id="'+ $(this).attr('id') 
        +'" src="'+ path +'cancel.png" />');
    });

    // Add AJAX functionality to clicking the cancel image.  This will remove
    // the group from the "dispatch to" groups.
    $('div.dispatch .info img')
      .bind('click', function() {
        // This regular expression will store the gid in g_matches[1].
        var g_matches = $(this).prev()
        .attr('href')
        .match(/\/node\/(\d+)/);
        
        // This will get us the parent form tag which has the nid in the id 
        // element and put it in n_matches[1].
        var n_matches = $(this).parent().prev().attr('id')
          .match(/comms-dispatch-node-(\d+)/);

        $.post('/comms/groups/'+ n_matches[1] +'/'+ g_matches[1] +'/remove', 
          null, comms_groups_process_delete);
        return false;
      });

    // Find each update groups form.
    $('div.comms_groups_form').each(function() {

      // This will get us the parent form tag which has the nid in the id 
      // element and put it in n_matches[1].
      var nid = $('input', this).val();

      // Set up handlers for clicks.
      $('select option', this).bind('click', function() {
        var gid = $(this).val();
        //$.post('/comms/groups/'+ n_matches[1] +'/'+ gid +'/add', 
        $.post('/comms/groups/'+ nid +'/'+ gid +'/add', 
          null, comms_groups_process_add);
      });

      $('select option:selected', this).hide();

      // If all options are selected we want to hide the whole form.
      var preselected = $('select option:selected', this);
      var testselected = $('select option:selected', this).length;
      var selected = 
        $('select option:selected', this).get().length;
      var options =
        $('select option', this).get().length;
      if (options == selected) {
        console.log(nid +': '+ selected +' vs. '+ options);
        $(this).hide();
      }

      // Hide the submit button.
      $('input.comms_group_submit', this).hide();

      // Hide the selected fields buttons.
      $('option:selected', this).hide();

    });

    // If the 'Associate groups and comms nodes with tags' feature is added
    // we will be able to process a list of tags.  The same functionality
    // should apply to this select list as the groups select list.
    $('.comms div.group_tag').each(function() {
        //var nid = $(this).val();
        var nid = $(this).attr('value');

        // Set up handlers for clicks.
        $('select option', this).bind('click', function() {
          var tid = $(this).val();
          //$.post('/comms/groups/'+ n_matches[1] +'/'+ gid +'/add', 
          $.post('/comms/groups/'+ nid +'/'+ tid +'/add/tags', 
            null, comms_tags_process_add);
        });

        // Hide all the selected terms.
        $('select option:selected', this).hide();
        
        // Hide the form submit button.
        $('input.form-submit', this).hide();
        
        // Hide the form if all elements are selected.
        var selected = 
          $('select option:selected', this).get().length;
        var options =
          $('select option', this).get().length;
        if (options == selected) {
          $(this).hide();
        }
    });
        
    // Add the delete icon to the links at the bottom of the node, and 
    // replace the link with just the text.  Then bind an action to the
    // delete icon.
    $('.comms').each(function() {
      var matches = $('.node', this).attr('id').match(/node-(\d+)/);
      var nid = matches[1];
      var comms = this;

      $('.terms a', this).each(function() {
        var a_matches = 
          $(this).attr('href').match(/\/taxonomy\/term\/(\d+)/);
        var tid = a_matches[1];
        $(this)
          .after('<img id="'+tid+'" src="'+ path +'cancel.png" />');
        $('.terms img#'+tid, comms).bind('click', function() {
          $.post('/comms/groups/'+ nid +'/'+ tid +'/remove/tags', 
            null, comms_tags_process_delete);
        });

        // Incomment this if you do not want the taxonomy link.
        //$(this).replaceWith($(this).text());
        $(this).after(': ');
      });

      // If no terms are associated with the node the .terms section does
      // not exist.  We should add it hear if that is the case.
      if ($('.terms', this).length == 0) {
        $('.clear-block .meta', this)
          .append("<div class=\"terms\"><ul class=\"links inline\"></ul> </div>");
      }
    });

  });
};
