// This will add Behaviors to the Comms slim view.
// This is for D6
// Drupal.behaviors.commsAddGroup = function(context) {
if (Drupal.jsEnabled) {
  // Process the feedback from the AJAX delete function.
  var comms_slim_process_delete = function(data) {
    var result = Drupal.parseJson(data);

    // In case a delete was requested and the previous confirmation did not time
    // out, clear it.  Then if we recieved a new confirmation display it and 
    // schedule the removal.
    if (result.confirmation.length) {
      if (! $('.view-comms-slim .message').length) {
        $('.view-comms-slim').prepend('<div class="message"></div>');
        $('.view-comms-slim .message').hide();
      }
      $('.view-comms-slim .message').html(result.confirmation);
      $('.view-comms-slim .message')
        .append('<br /><a href="#" id="yes">Yes</a>, '+
          '<a href="#" id="cancel">cancel</a>');
      $('.view-comms-slim .message a#yes').bind('click', function() {
        $.post('/comms/delete/'+ result.nids.split(' ').join('+') +'/1', 
          null, comms_slim_process_delete);
        return false;
      });
      $('.view-comms-slim .message a#cancel').bind('click', function() {
        $('.view-comms-slim .message').fadeOut("slow");
      });

      $('.view-comms-slim .message').fadeIn("slow");
      return;
    }
    // In case a delete was requested and the previous message did not time
    // out, clear it.  Then if we recieved a new message display it and 
    // schedule the removal.
    if (result.message.length) {
      if (! $('.view-comms-slim .message').length) {
        $('.view-comms-slim').prepend('<div class="message"></div>');
        $('.view-comms-slim .message').hide();
      }
      $('.view-comms-slim .message').html(result.message);
      $('.view-comms-slim .message').fadeIn("slow");
      setTimeout(function() {
        $('.view-comms-slim .message').fadeOut("slow");
        }, 5000);
      if (result.error) {
        return;
      }
    }

    // If we get here then we have deleted some nodes.
    $('.view-comms-slim .view-field-node-delete input#check-all')
      .removeAttr('checked');
    $('.view-comms-slim tr').each(function() {
      var nid = $('.view-field-node-delete img', this).attr('id');
      if (!nid) {
        return;
      }
      var re = new RegExp('[^\d]?'+ nid +'[^\d]?');
      if (result.nids.match(re)) {
        $(this).remove();
      }
    });

    // Re zebra the output.
    if ($('.view-comms-slim tr').get().length <= 1) {
      $('.view-comms-slim').replaceWith('There are no comms nodes matching '+
          'your search criteria.');
    }
    else {
      var zebra = 0;
      $('.view-comms-slim tr').each(function() {
          zebra++;
          if (zebra % 2 == 0) {
            $(this).attr('class', 'even');
          }
          else {
            $(this).attr('class', 'odd');
          }
      });
    }
  }

  // This is the main code that should be run on the comms slim view.
  $(document).ready(function () {
    // Get the path that this js is in.  This is a total hack!
    //var path = $('head script').attr('src').grep(function(src) {
    //$('head script').each(function(script) {
    var path = '';
    $('head script').each(function() {
      var matches = $(this).attr("src").match(/(.*)comms\.slim\.js/);
      if (matches && matches.length == 2) {
        path = matches[1];
      }
    });

    // Replace the Delete link with the cancel icon.  With AJAX delete
    // abilities.  Can we add in a prompt?
    $('.view-comms-slim .view-field-node-delete').each(function() {
      // The table header will be the first row we see and will no contain the
      // delete link.  We will turn this into a Delete all checked link, with
      // a check all checkbox next to it.
      if (! $('a', this).attr('href')) {
        $(this).html('<a href="#">Delete</a>');
        $('a', this).bind('click', function() {
          // Get a list of all checked nids.
          var nids = 
            $('.view-comms-slim .view-field-node-delete input:checked:not(#check-all)')
            .map(function() { 
              return $(this).val(); 
            });
          $.post('/comms/delete/'+ nids.get().join('+'), 
            null, comms_slim_process_delete);
          return false;
        });

        $(this).append('<input type="checkbox" id="check-all">');
        $('input', this).bind('click', function() {
          if ($(this).is(':checked')) {
            $('.view-comms-slim .view-field-node-delete input').attr('checked', 'checked');
          }
          else {
            $('.view-comms-slim .view-field-node-delete input').removeAttr('checked');
          }
        });
      }
      else {
        // Get the nid, append a cancel link icon, and bind a click handler.
        var nid = $('a', this).attr('href').match(/\/node\/(\d+)/)[1];
        $(this).html('<img id="'+ nid +'" src="'+ path +'cancel.png" />')
        $('img', this).bind('click', function() {
          $.post('/comms/delete/'+ nid, 
            null, comms_slim_process_delete);
          return false;
        });

        // Append a checkbox as well.
        $(this).append('<input type="checkbox" value="'+ nid +'">');
      }
    });
     
    // Add checkboxes next to each delete icon.
    
    // The Delete header column should be click bound to a function that will 
    // pass all checked entries to the AJAX delete function.
    
    // Add a check box next to the Delete header that will check all visible
    // check boxes, providing a simple way to select all comms entries for 
    // deletion.

  });
};
